#include "HelperFunctions.h"

int Helpers::getOpenObjNum()
{
	for (int i=1; i<30000; i++)
	{
		if (dbObjectExist(i) == 0)
			return i;
	}

	return -1;
}


int Helpers::getOpenImageNum()
{
	for (int i=1; i<30000; i++)
	{
		if (dbImageExist(i) == 0)
			return i;
	}

	return -1;
}

int Helpers::getOpenSoundNum()
{
	for (int i=1; i<30000; i++)
	{
		if (dbSoundExist(i) == 0)
			return i;
	}

	return -1;
}

int Helpers::getOpenMusicNum()
{
	for (int i=1; i<30000; i++)
	{
		if (dbMusicExist(i) == 0)
			return i;
	}

	return -1;
}

int Helpers::getOpenMemblockNum()
{
	for (int i=1; i<512; i++)
	{
		if (dbMemblockExist(i) == 0)
			return i;
	}

	return -1;
}

int Helpers::getOpenMeshNum()
{
	for (int i=1; i<512; i++)
	{
		if (dbMeshExist(i) == 0)
			return i;
	}

	return -1;
}

int Helpers::getOpenSpriteNum()
{
	for (int i=1; i<10000; i++)
	{
		if (dbSpriteExist(i) == 0)
			return i;
	}

	return -1;
}


void Helpers::makeFloatMatrix( dVector rot, dVector pos, float* matrix )
{
	// first convert rotation to radians.
	rot.m_x = rot.m_x * ( 3.14159f / 180.0f );
	rot.m_y = rot.m_y * ( 3.14159f / 180.0f );
	rot.m_z = rot.m_z * ( 3.14159f / 180.0f );

	// now get basic matrix.
	NewtonSetEulerAngle( &rot.m_x, matrix );

	// finally add position element.
	matrix[12] = pos.m_x;
	matrix[13] = pos.m_y;
	matrix[14] = pos.m_z;
}

dMatrix Helpers::makedMatrixFromEulerPos( dVector Euler, dVector pos )
{
	dMatrix ret;

	// first convert rotation to radians.
	Euler.m_x = Euler.m_x * ( 3.14159f / 180.0f );
	Euler.m_y = Euler.m_y * ( 3.14159f / 180.0f );
	Euler.m_z = Euler.m_z * ( 3.14159f / 180.0f );

	// now get basic matrix.
	NewtonSetEulerAngle( &Euler.m_x, &ret.m_front.m_x );

	ret.m_posit = pos;

	return ret;
}

float Helpers::dVectorLength( dVector& vec )
{
	return sqrt( (vec.m_x*vec.m_x) + (vec.m_y*vec.m_y) + (vec.m_z*vec.m_z) );
}


dVector Helpers::CalcSphereSolid( float mass, float radius )
{
	dVector inertia;

	inertia.m_x = (2.0f * mass * (radius * radius)) / 5.0f;
	inertia.m_y = inertia.m_z = inertia.m_x;

	return inertia;
}


dVector Helpers::CalcBoxSolid(float mass, dVector size )
{
	dVector inertia;

	inertia.m_x = (mass * ((size.m_y * size.m_y) + (size.m_z * size.m_z))) / 12.0f;
	inertia.m_y = (mass * ((size.m_x * size.m_x) + (size.m_z * size.m_z))) / 12.0f;
	inertia.m_z = (mass * ((size.m_y * size.m_y) + (size.m_x * size.m_x))) / 12.0f;

	return inertia;
}