/*
	ConnectMore project

	by Walaber

	CLASS: Overflowchecker- a raycast-based checker used to determine when the player has lost.
*/

#ifndef _OVERFLOW_CHECKER_INCLUDED_
#define _OVERFLOW_CHECKER_INCLUDED_

#include "Prereqs.h"

#include "HelperFunctions.h"
#include <Newton.h>
#include <DarkSDK.h>


class OverflowChecker
{
public:
	OverflowChecker( NewtonWorld* world, dVector start, dVector end, float timeToSetOff );

	~OverflowChecker();


	// basic update command.  returns a 1 if the ray has been properly tripped, otherwise 0.
	int update( float timeStep );

private:
	dVector mStart;
	dVector mEnd;

	int mObjNum;

	float mRayDist;

	float mTimeToSetOff;
	float mTimeTripped;

	float mGoalLength;

	NewtonWorld* mWorld;


	// newton raycasl callback.
	static float _cdecl newtonRaycastCallback(const NewtonBody* body, const float* hitNormal, int collisionID, void* userData, float intersetParam);
};



#endif	// _OVERFLOW_CHECKER_INCLUDED_