#include "SFXManager.h"

SFXManager::SFXManager()
{
}


SFXManager::~SFXManager()
{
	while (mObjects.size() > 0)
	{
		SFXManager::SFXObject* obj = mObjects.back();
		mObjects.pop_back();

		delete obj;
	}
}


SFXManager& SFXManager::getSingleton()
{
	static SFXManager instance;

	return instance;
}


void SFXManager::addSFXObject( SFXManager::SFXObject* obj )
{
	// add this object to the list.
	mObjects.push_back( obj );
}


void SFXManager::updateAll( float timeStep )
{
	std::vector<SFXManager::SFXObject*> toDelete;

	for(SFXObjectListIterator it = mObjects.begin(); it != mObjects.end(); it++)
	{
		// update the object.
		(*it)->_update( timeStep );

		// needs to be deleted?
		if ((*it)->_deleteme())
		{
			// this one is done
			SFXObject* obj = (*it);
			
			toDelete.push_back( obj );			
		}
	}

	while (toDelete.size() > 0)
	{
		SFXObject* obj = toDelete.back();

		mObjects.remove( obj );
		
		delete obj;

		toDelete.pop_back();
		
	}
}


