/*
	ConnectMore project

	by Walaber

	CLASS: SFX_Bomb - sfx effect for the bomb ball.
*/

#ifndef _SFXBOMB_INCLUDED_
#define _SFXBOMB_INCLUDED_

#include "Prereqs.h"

#include "SFXManager.h"
#include "HelperFunctions.h"
#include "WorldInfo.h"
#include "SFX_Smoke.h"
#include "BasicBall.h"
#include <newton.h>
#include <DarkSDK.h>

class SFX_Bomb : public SFXManager::SFXObject
{
public:
	// constructor
	SFX_Bomb( BasicBall* bomb, dVector pos, int numParticles );

	// destructor
	~SFX_Bomb();

	// main update function
	void _update( float timeStep );

	// let the manager know when to destroy this object.
	bool _deleteme();


private:
	// individual particle class
	
	class DebrisParticle
	{
	public:
		DebrisParticle( dVector pos, dVector vel, float spin, float life, int objNum );

		~DebrisParticle();

		void update( float timeStep );


		float mLife;

	private:
		int mObjNum;
		dVector mPos;
		dVector mVel;
		float mSpin;
	};


	typedef std::list<DebrisParticle*> DebrisParticleList;
	typedef std::list<DebrisParticle*>::iterator DebrisParticleListIterator;

	DebrisParticleList mParticles;

	int mBaseDebrisObjNum;

	// smoke (fire) particles.
	SFX_Smoke::SmokeParticleList mFire;

	// newton callback.
	static void _cdecl newtonBombApply( const NewtonBody* body );

	float mDeleteDelay;

};


#endif	// _SFXBOMB_INCLUDED_