/*
	ConnectMore project

	by Walaber

	CLASS: SFXKillBall - the main special effect for when a ball is destroyed on the playfield.
*/

#ifndef _SFXKILLBALL_INCLUDED_
#define _SFXKILLBALL_INCLUDED_

#include "Prereqs.h"

#include "SFXManager.h"
#include "HelperFunctions.h"
#include "3dmath.h"
#include <DarkSDK.h>

class SFX_KillBall : public SFXManager::SFXObject
{
public:
	// constructor
	SFX_KillBall( dVector pos, int objID );

	// destructor
	~SFX_KillBall();

	// main update function
	void _update( float timeStep );

	// let the manager know when to destroy this object.
	bool _deleteme();


private:

	// main object number.
	int mObjNum;

	// time left to live.
	float mLifeLeft;

};


#endif	// _SFXKILLBALL_INCLUDED_