#include "SkySphere.h"


SkySphere::SkyPiece::SkyPiece(char* objfile, int imgNum)
{
	mObjNum = Helpers::getOpenObjNum();
	dbLoadObject( objfile, mObjNum );
	dbPositionObject( mObjNum, 0.0f, 58.0f, 0.0f );

	dbTextureObject( mObjNum, imgNum );
	//dbSetObjectLight( mObjNum, 0 );

	mAngle = 0.0f;
}

SkySphere::SkyPiece::~SkyPiece()
{
	dbDeleteObject( mObjNum );
}



SkySphere::SkySphere(char* objfile, char* imgfile )
{
	mImgNum = Helpers::getOpenImageNum();
	dbLoadImage( imgfile, mImgNum );

	float angle = -90.0f;
	for (int i=0; i<3; i++)
	{
		SkyPiece* temp = new SkyPiece( objfile, mImgNum );
		temp->setAngle( angle );
		angle += 90.0f;

		mPieces.push_back( temp );
	}


};


SkySphere::~SkySphere()
{
	dbDeleteImage( mImgNum );

	while (mPieces.size() > 0)
	{
		SkyPiece* kill = mPieces.back();

		delete kill;

		mPieces.pop_back();
	}
}


void SkySphere::update( float timeStep, float rotSpeed )
{
	for (SkyPieceVectorIterator it = mPieces.begin(); it != mPieces.end(); it++)
	{
		float ang = (*it)->getAngle();
		
		ang += (timeStep * rotSpeed);

		if (ang > 180.0f)
		{
			ang = -90.0f;
		}

		(*it)->setAngle( ang );

		dbScrollObjectTexture( (*it)->getObjNum(), rotSpeed * 0.01 * timeStep, 0.0f );
	}
	
}

