#include "UserCrosshair.h"

UserCrosshair::UserCrosshair(char* filename1, char* filename2, dVector pos, dVector min, dVector max)
{
	mMin = min;
	mMax = max;

	mObjNum1 = Helpers::getOpenObjNum();
	dbLoadObject( filename1, mObjNum1 );
	dbColorObject( mObjNum1, dbRgb(255,0,0) );
	//dbGhostObjectOn( mObjNum1, 1 );
	dbScaleObject( mObjNum1, 15.0, 15.0, 15.0 );

	mObjNum2 = Helpers::getOpenObjNum();
	dbLoadObject( filename2, mObjNum2 );
	dbColorObject( mObjNum2, dbRgb(196,0,0) );
	//dbGhostObjectOn( mObjNum2, 1 );
	dbScaleObject( mObjNum2, 15.0, 15.0, 15.0 );

	// set initial position
	setPosition( pos );
}


UserCrosshair::~UserCrosshair()
{
	dbDeleteObject( mObjNum1 );
	dbDeleteObject( mObjNum2 );
}


dVector UserCrosshair::getPosition()
{
	dVector ret;

	ret.m_x = dbObjectPositionX( mObjNum1 );
	ret.m_y = dbObjectPositionY( mObjNum1 );
	ret.m_z = dbObjectPositionZ( mObjNum1 );

	return ret;
}


void UserCrosshair::setPosition( dVector newpos )
{
	if (newpos.m_x < mMin.m_x) { newpos.m_x = mMin.m_x; }
	if (newpos.m_y < mMin.m_y) { newpos.m_y = mMin.m_y; }
	if (newpos.m_z < mMin.m_z) { newpos.m_z = mMin.m_z; }

	if (newpos.m_x > mMax.m_x) { newpos.m_x = mMax.m_x; }
	if (newpos.m_y > mMax.m_y) { newpos.m_y = mMax.m_y; }
	if (newpos.m_z > mMax.m_z) { newpos.m_z = mMax.m_z; }

	dbPositionObject( mObjNum1, newpos.m_x, newpos.m_y, newpos.m_z );
	dbPositionObject( mObjNum2, newpos.m_x, newpos.m_y, newpos.m_z );
}

void UserCrosshair::update( float timeStep )
{
	dbRollObjectLeft( mObjNum1, timeStep * 25.0f );
	dbRollObjectRight( mObjNum2, timeStep * 15.0f );
}